#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "osint.h"
#include "conion.h"

char *MainLoader =
"> 00 fe 65 fd 00 00 8c fc 20 7e 65 fd 24 08 60 fd > 24 28 60 fd 02 00 80 ff 28 12 64 fd 08 08 dc fc > 4f 7e 74 fd 01 24 84 f0 01 00 80 ff 28 5c 65 fd > 18 24 44 f0 13 24 60 fd f4 23 6c fb 00 00 7c fc > 00 00 ec fc";

static char buffer[1024];

void putch(int val)
{
    putchar(val);
    fflush(stdout);
}

void getst(char *outstr)
{
    int val;
    int count = 0;
    while (1)
    {
        while (!kbhit()) printf("Loop %d\n", count++);
        val = getch();
        if (val == 10 || val == 13)
        {
            *outstr = 0;
            break;
        }
        else
        {
            printf("%c", val);
            fflush(stdout);
            *outstr++ = val;
        }
    }
}

void PrintString(char *str)
{
    while (*str)
    {
        putchar(*str);
        if (*str == 13) putchar(10);
        str++;
    }
    fflush(stdout);
}

void usage(void)
{
    printf("usage: loadp2 port file [-t]\n");
    exit(1);
}

int loadfile(char *fname)
{
    FILE *infile;
    int num, size;

    infile = fopen(fname, "r");
    if (!infile)
    {
        printf("Could not open %s\n", fname);
        return 1;
    }
    fseek(infile, 0, SEEK_END);
    size = ftell(infile);
    fseek(infile, 0, SEEK_SET);
    sprintf(buffer, " %2.2x %2.2x %2.2x %2.2x ",
        size&255, (size >> 8) & 255, (size >> 16) & 255, (size >> 24) & 255);
    printf("Loading %s - %d bytes\n", fname, size);
    hwreset();
    usleep(50000);
    tx((uint8_t *)"> Prop_Hex 0 0 0 0 ", 19);
    tx((uint8_t *)MainLoader, strlen(MainLoader));
    tx((uint8_t *)buffer, strlen(buffer));
    tx((uint8_t *)"~", 1);
    usleep(50000);
    while ((num=fread(buffer, 1, 1024, infile)))
    {
        tx((uint8_t *)buffer, num);
    }
    printf("%s loaded\n", fname);
    return 0;
}

int main(int argc, char **argv)
{
    int val, num;
    int runterm = 0;

    if (argc == 4)
    {
        argc--;
        runterm = 1;
        if (strcmp(argv[3], "-t")) usage();
    }

    if (argc != 3) usage();

    if (1 != serial_init(argv[1], 115200))
    {
        printf("Could not open port %s\n", argv[1]);
        exit(1);
    }

    initialize_console_io();

    if (loadfile(argv[2]))
    {
        restore_console_io();
        serial_done();
        exit(1);
    }

    if (runterm)
    {
        printf("[ Entering terminal mode.  Press ESC to exit. ]\n");
        while (1)
        {
            if (kbhit())
            {
                val = getch();
                if (val == 27)
                    break;
                else
                    tx((uint8_t *)&val, 1);
            }
            num = rx((uint8_t *)buffer, 100);
            if (num)
            {
                buffer[num] = 0;
                PrintString(buffer);
            }
        }
    }

    restore_console_io();
    serial_done();

    return 0;
}
